package com.huawei.dli.jdbc.model;

import com.huawei.dli.jdbc.utils.ErrorCode;

import java.sql.SQLException;

public class DliException extends SQLException {
    private String errorCode;

    private String message;

    public DliException(Throwable cause) {
        super(cause);
    }

    public DliException(String message) {
        this.message = message;
    }

    public DliException(String message, String errorCode) {
        this(message, errorCode, null);
    }

    public DliException(String message, String errorCode, Throwable cause) {
        super(message, cause);
        this.errorCode = errorCode;
        this.message = message;
    }

    @Override
    public String getMessage() {
        return errorCode + ": " + message;
    }

    @Override
    public int getErrorCode() {
        return ErrorCode.valueOf(errorCode).getErrorCodeIndex();
    }
}
